%define name		tomcat4
%define full_name	jakarta-%{name}
%define version		4.1.27
%define majversion	4.1
%define release		2jpp
%define section		free

%define summary		Apache Servlet/JSP Engine, RI for Servlet 2.3/JSP 1.2 API
%define license		Apache Software License
%define distribution	JPackage
%define vendor		JPackage Project

%define jname		jasper4
%define tcuid		91

%define packname 	jakarta-tomcat-%{version}
%define packdname	jakarta-tomcat-%{version}-src
%define jpackdname	jakarta-tomcat-connectors-%{version}-src

# FHS 2.2 compliant tree structure
# see http://www.pathname.com/fhs/2.2/
%define confdir		%{_sysconfdir}/%{name}
%define logdir		%{_localstatedir}/log/%{name}
%define homedir		%{_datadir}/%{name}
%define bindir		%{_datadir}/%{name}/bin
%define tempdir		%{_localstatedir}/cache/%{name}/temp
%define workdir		%{_localstatedir}/cache/%{name}/work
%define appdir		%{_localstatedir}/lib/%{name}/webapps
%define serverdir	%{_localstatedir}/lib/%{name}/server
%define commondir	%{_localstatedir}/lib/%{name}/common
%define shareddir	%{_localstatedir}/lib/%{name}/shared

Summary: 		%{summary}
Name: 			%{name}
Version: 		%{version}
Release: 		%{release}
Epoch:			0
License:		%{license}
Vendor:			%{vendor}
Distribution:		%{distribution}
Group: 			Networking/Daemons
URL: 			http://jakarta.apache.org/tomcat/
BuildArch: 		noarch
Source:			http://jakarta.apache.org/builds/jakarta-tomcat-4.0/release/v%{version}/src/%{packdname}.tar.gz
Source1:		http://jakarta.apache.org/builds/jakarta-tomcat-4.0/release/v%{version}/src/%{jpackdname}.tar.gz
Source2:		mod_jk.jpeg
Source3:		TOMCAT4.README.RPM
Source4: 		%{name}-%{majversion}.init
Source5:		%{name}-%{majversion}.conf
Source6:		%{name}-%{majversion}.wrapper
Source7:		jasper4-%{majversion}.wrapper
Source8:		%{name}-%{majversion}.logrotate
Source9:		%{name}-%{majversion}.relink
Patch0:			tomcat4-%{version}.patch
Patch1:                 %{name}-%{majversion}.link_admin_jar.patch
BuildRoot:		%{_tmppath}/%{name}-root-%{version}

Requires:		ant >= 0:1.5, jpackage-utils >= 0:1.5.24
# xml parsing - isn't this already required by ant ?
Requires:		jaxp_parser_impl, xml-commons-apis
Requires:		regexp >= 0:1.2, servletapi4 >= 0:4.0.4, tyrex >= 0:1.0
# jakarta packages
Requires:		jakarta-commons-beanutils >= 0:1.4.1, jakarta-commons-collections >= 0:2.0
Requires:		jakarta-commons-daemon, jakarta-commons-dbcp, jakarta-commons-digester >= 0:1.3
Requires:		jakarta-commons-modeler, jakarta-commons-pool >= 0:1.0.1
Requires:		jakarta-commons-logging >= 0:1.0.1, jakarta-commons-fileupload >= 0:1.0-1jpp
# alternatives
Requires:		jmxri, jaas, jndi, jndi-ldap, jdbc-stdext
# non-free stuff
Requires:		jta >= 0:1.0.1-0.a.1, jaf >= 0:1.0.1, javamail >= 0:1.3

BuildRequires:		ant >= 0:1.5, ant-optional >= 0:1.5, xalan-j2
Buildrequires:		jpackage-utils >= 0:1.5.24
BuildRequires:		jakarta-commons-beanutils, jakarta-commons-collections >= 0:2.0
BuildRequires:		jakarta-commons-daemon, jakarta-commons-dbcp, jakarta-commons-digester >= 0:1.3
BuildRequires:		jakarta-commons-logging >= 0:1.0.1, jakarta-commons-fileupload >= 0:1.0
BuildRequires:		jakarta-commons-modeler, jakarta-commons-pool >= 0:1.0.1
BuildRequires:		jaas, jaf >= 0:1.0.1, javamail >= 0:1.3, jdbc-stdext >= 0:2.0
BuildRequires:		jndi >= 0:1.2.1, jndi-ldap, jsse >= 0:1.0.2, jta >= 0:1.0.1-0.a.1
BuildRequires:		junit >= 0:3.7, jmxri
BuildRequires:		regexp = 0:1.2, puretls, servletapi4 >= 0:4.0.4, servletapi4-javadoc >= 0:4.0.4
BuildRequires:		struts >= 0:1.0.2, tyrex = 0:1.0, jaxp_parser_impl, xml-commons-apis

%description
Server that conforms to the Servlet 2.3 and JSP 1.2
specifications from Java Software.


Develop Web applications in Java.

%package webapps
Group:			System Environment/Applications
Requires:		%{name} = %{epoch}:%{version}-%{release}
Summary:		Web Applications for tomcat

%description webapps
Web Applications for tomcat

%package admin-webapps
Group:			System Environment/Applications
Requires:		%{name} = %{epoch}:%{version}-%{release}
Requires:		struts >= 0:1.0.2
Summary:		Admin Web Applications for tomcat

%description admin-webapps
Admin Web Applications for tomcat

%package compat
Group:                  Networking/Daemons
Requires:               %{name} = %{epoch}:%{version}-%{release}
Summary:                Compatibility symlinks to old JPackage 1.0 file layout

%description compat
This package includes compatibility symlinks to simulate old pre-FHS %{name}
file layout.
It is provided as a short-term workaround - do not rely on it.

%prep
rm -rf $RPM_BUILD_DIR/%{name}-%{version}

%setup -q -c -T -a 0
%setup -q -T -D -a 1

cd %{packdname}
%patch0
%patch1 -p1

%build
export CLASSPATH=%(build-classpath xml-commons-apis xalan-j2 servletapi4)

# Remove pre-build jars
for dir in %{packdname} %{jpackdname} ; do
    find $dir -name "*.jar" -exec rm -f {} \;
done

# build tomcat 4
cd %{packdname}

cat >> build.properties <<EOBP
ant.jar=%{_javadir}/ant.jar
jtc.home=$RPM_BUILD_DIR/%{name}-%{version}/jakarta-tomcat-connectors-%{version}-src/
jasper.home=./jasper
commons-beanutils.jar=$(build-classpath commons-beanutils)
commons-fileupload.jar=$(build-classpath commons-fileupload)
commons-collections.jar=$(build-classpath commons-collections)
commons-daemon.jar=$(build-classpath commons-daemon)
commons-dbcp.jar=$(build-classpath commons-dbcp)
commons-digester.jar=$(build-classpath commons-digester)
commons-logging.jar=$(build-classpath commons-logging)
commons-logging-api.jar=$(build-classpath commons-logging-api)
commons-modeler.jar=$(build-classpath commons-modeler)
commons-pool.jar=$(build-classpath commons-pool)
jmx.jar=$(build-classpath jmxri)
jmxri.jar=$(build-classpath jmxri)
junit.jar=$(build-classpath junit)
regexp.jar=$(build-classpath regexp-1.2)
servlet.jar=$(build-classpath servletapi4)
servlet.doc=%{_javadocdir}/servletapi4
xercesImpl.jar=$(build-classpath jaxp_parser_impl)
xmlParserAPIs.jar=$(build-classpath xml-commons-apis)
struts.jar=$(build-classpath struts)
struts.lib=%{_datadir}/struts
activation.jar=$(build-classpath jaf)
mail.jar=$(build-classpath javamail/mailapi)
jta.jar=$(build-classpath jta)
tyrex.jar=$(build-classpath tyrex)
jaas.jar=$(build-classpath jaas)
jndi.jar=$(build-classpath jndi)
jdbc20ext.jar=$(build-classpath jdbc-stdext)
puretls.jar=$(build-classpath puretls)
jcert.jar=$(build-classpath jsse/jcert)
jnet.jar=$(build-classpath jsse/jnet)
jsse.jar=$(build-classpath jsse/jsse)
EOBP

# can't use jikes to build tomcat4 (strange)
ant -Djava.home=%{java_home} -Dbuild.compiler=modern

# rename servletapi4.jar to servlet.jar (coyote need it)
ln -s build/common/lib/servletapi4.jar build/common/lib/servlet.jar

%install
rm -rf $RPM_BUILD_ROOT

# install RPM README
cp %{SOURCE3} .

export CLASSPATH=%(build-classpath xalan-j2 xml-commons-apis)

# build initial path structure
install -d -m 755 $RPM_BUILD_ROOT/{%{confdir},%{logdir},%{homedir},%{bindir}}
install -d -m 755 $RPM_BUILD_ROOT/{%{serverdir},%{tempdir},%{workdir}}
install -d -m 755 $RPM_BUILD_ROOT/{%{appdir},%{commondir},%{shareddir}}

install -d -m 755 $RPM_BUILD_ROOT/{%{_bindir},%{_sysconfdir}/{init.d,logrotate.d},%{_javadir}}

install -m 755 %{SOURCE9} $RPM_BUILD_ROOT/%{bindir}/relink

# sysv init and logging
install %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}/init.d/%{name}
install %{SOURCE5} $RPM_BUILD_ROOT/%{confdir}/%{name}.conf

cd %{packdname}
export usejikes=false
ant -Djava.home=$JAVA_HOME dist
pushd dist
    mv bin/*     ${RPM_BUILD_ROOT}%{bindir}
    mv common/*  ${RPM_BUILD_ROOT}%{commondir}
    mv conf/*    ${RPM_BUILD_ROOT}%{confdir}
    mv server/*  ${RPM_BUILD_ROOT}%{serverdir}
    mv shared/*  ${RPM_BUILD_ROOT}%{shareddir}
    mv webapps/* ${RPM_BUILD_ROOT}%{appdir}
    mv temp/*    ${RPM_BUILD_ROOT}%{tempdir}
popd

# create reloctomcat4
cat >> $RPM_BUILD_ROOT%{bindir}/reloctomcat4<<EORLTC
#!/bin/sh
#

echo "relocating http & ajp ports to 81xx"

sed -e 's;8080;8180;' \
    -e 's;8081;8181;' \
    -e 's;8082;8182;' \
    -e 's;8443;8543;' \
    -e 's;8009;8109;' \
    %{confdir}/server.xml > %{confdir}/server.xml.reloc

mv %{confdir}/server.xml %{confdir}/server.xml.bak
cp %{confdir}/server.xml.reloc %{confdir}/server.xml

EORLTC


install $RPM_BUILD_ROOT%{bindir}/jspc.sh     $RPM_BUILD_ROOT%{_bindir}/jspc4

# rename catalina/jasper into dtomcat4/djasper4 to let wrapper take precedence
install $RPM_BUILD_ROOT%{bindir}/jasper.sh   $RPM_BUILD_ROOT%{_bindir}/d%{jname}
install $RPM_BUILD_ROOT%{bindir}/catalina.sh $RPM_BUILD_ROOT%{_bindir}/d%{name}
rm -f $RPM_BUILD_ROOT%{bindir}/catalina.sh.*
# Remove leftover files ?
rm -f $RPM_BUILD_ROOT%{bindir}/*.orig

# install wrapper as tomcat4/jasper4
install %{SOURCE6} $RPM_BUILD_ROOT%{_bindir}/%{name}
install %{SOURCE7} $RPM_BUILD_ROOT%{_bindir}/%{jname}

# install logrotate support
install %{SOURCE8} ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/%{name}

# remove / reorder non-usefull stuff
rm -rf $RPM_BUILD_ROOT%{homedir}/src/
rm -f  $RPM_BUILD_ROOT%{bindir}/*.sh $RPM_BUILD_ROOT%{bindir}/*.bat

# FHS compliance patches, not easy to track them all boys :)

for i in $RPM_BUILD_ROOT%{confdir}/%{name}.conf $RPM_BUILD_ROOT%{_bindir}/d%{name} \
         $RPM_BUILD_ROOT%{_bindir}/%{name} $RPM_BUILD_ROOT%{_sysconfdir}/init.d/%{name} \
         $RPM_BUILD_ROOT%{_bindir}/d%{jname} $RPM_BUILD_ROOT%{_bindir}/%{jname} \
         $RPM_BUILD_ROOT%{bindir}/relink $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/%{name}
    do

    perl -pi -e "s|\@\@\@TCCONF\@\@\@|%{confdir}|g;" $i
    perl -pi -e "s|\@\@\@TCHOME\@\@\@|%{homedir}|g;" $i
    perl -pi -e "s|\@\@\@TCBIN\@\@\@|%{bindir}|g;" $i
    perl -pi -e "s|\@\@\@TCCOMMON\@\@\@|%{commondir}|g;" $i
    perl -pi -e "s|\@\@\@TCSERVER\@\@\@|%{serverdir}|g;" $i
    perl -pi -e "s|\@\@\@TCSHARED\@\@\@|%{shareddir}|g;" $i
    perl -pi -e "s|\@\@\@TCAPP\@\@\@|%{appdir}|g;" $i
    perl -pi -e "s|\@\@\@TCLOG\@\@\@|%{logdir}|g;" $i
done

### Replace local copies with jpp-compatible links
# Process server/lib
pushd   $RPM_BUILD_ROOT/%{serverdir}/lib
    find . -name "*.jar" -not -name "catalina*" \
                         -not -name "servlets-*" \
                         -not -name "tomcat-*" \
                         -exec rm -f {} \;

    # catalina-ant will be installed in a public repository
    mv catalina-ant.jar $RPM_BUILD_ROOT/%{_javadir}/catalina-ant-%{version}.jar

    pushd $RPM_BUILD_ROOT/%{_javadir}
        ln -fs catalina-ant-%{version}.jar catalina-ant.jar
    popd
popd

# Process admin webapp server/webapps/admin
pushd $RPM_BUILD_ROOT/%{serverdir}/webapps/admin/WEB-INF/lib
    find . -name "*.jar" -exec rm -f {} \;
popd

# Process common/lib
pushd $RPM_BUILD_ROOT/%{commondir}/lib
    find . -name "*.jar" -not -name "jasper*" \
                         -not -name "naming*" \
                         -exec rm -f {} \;
popd

# Process common/lib
pushd $RPM_BUILD_ROOT/%{commondir}/endorsed
    find . -name "*.jar" -exec rm -f {} \;
popd

# avoid duplicate servlet.jar
rm -f $RPM_BUILD_ROOT%{commondir}/lib/servlet.jar

# fix mod_jk.jpeg (mine ;) which has been broken somewhere (cvs client ?)
cp %{SOURCE2} ${RPM_BUILD_ROOT}%{appdir}/tomcat-docs/jk2/images/

# Perform FHS translation
# (final links)
pushd $RPM_BUILD_ROOT%{homedir}
   [ -d bin ]     || ln -fs %{bindir}    bin
   [ -d common ]  || ln -fs %{commondir} common
   [ -d conf ]    || ln -fs %{confdir}   conf
   [ -d logs ]    || ln -fs %{logdir}    logs
   [ -d server ]  || ln -fs %{serverdir} server
   [ -d shared ]  || ln -fs %{shareddir} shared
   [ -d webapps ] || ln -fs %{appdir}    webapps
   [ -d work ]    || ln -fs %{workdir}   work
   [ -d temp ]    || ln -fs %{tempdir}   temp
popd

# Create compat symlinks
# With Jpackage 1.0 rpm
pushd $RPM_BUILD_ROOT
   [ -d var ] || install -d -m 0755 var
   ln -fs %{homedir} var/tomcat4
   [ -d etc/tomcat4 ] || install -d -m 0755 etc/tomcat4
   ln -fs %{confdir} etc/tomcat4/conf
popd
# For Borland JBuilder
# Since we do not ensure a 1/1 jar mapping this won't always work
# actual links created in %post
pushd $RPM_BUILD_ROOT/%{commondir}/lib
   touch ant.jar servlet.jar
popd
pushd $RPM_BUILD_ROOT/%{commondir}/endorsed
   touch xercesImpl.jar xmlParserAPIs.jar
popd

find $RPM_BUILD_ROOT%{homedir} -type l -maxdepth 1 | sed s+$RPM_BUILD_ROOT++g > homelinks


%clean
rm -rf $RPM_BUILD_ROOT


%post
# install tomcat4 (but don't activate)
/sbin/chkconfig --add %{name}

[ $1 = 1 ] && /bin/cat << EOF_INFO

For security purposes, the %{name} service is installed but not
activated by default. Use your service installer for such purposes
(ntsysv, setup, redhat-config-services...)

The %{name} service is controled by %{confdir}/%{name}.conf -
customizing it is usually a good idea.

EOF_INFO

### Create automated links
### Since all needed extensions may not have been installed for this jvm
### output is muted

# Try to set a sensible jvm
unset JAVA_HOME
[ -r %{confdir}/tomcat4.conf ] && . %{confdir}/tomcat4.conf
[ -z "$JAVA_HOME" ] && [ -r %{_sysconfdir}/java/java.conf ] && . %{_sysconfdir}/java/java.conf
[ -z "$JAVA_HOME" ] && JAVA_HOME=%{_jvmdir}/java

# Remove old automated symlinks
# we do not want old links if a jar is removed from tomcat's layout
for repository in %{serverdir}/lib \
                  %{commondir}/lib \
                  %{commondir}/endorsed ; do
    find $repository -name '\[*\]*.jar' -not -type d -exec rm -f {} \;
done

build-jar-repository %{serverdir}/lib commons-beanutils commons-fileupload \
                                      commons-digester commons-logging \
                                      commons-modeler regexp-1.2 jmxri jaas \
                                      catalina-ant 2>&1

build-jar-repository %{commondir}/lib ant commons-collections commons-dbcp \
                                      commons-pool commons-logging-api jaf \
                                      jdbc-stdext jta javamail jndi servletapi4 \
                                      2>&1

build-jar-repository %{commondir}/endorsed jaxp_parser_impl xml-commons-apis 2>&1


%post admin-webapps

### Create automated links
### Since all needed extensions may not have been installed for this jvm
### output is muted

# Try to set a sensible jvm
unset JAVA_HOME
[ -r %{confdir}/tomcat4.conf ] && . %{confdir}/tomcat4.conf
[ -z "$JAVA_HOME" ] && [ -r %{_sysconfdir}/java/java.conf ] && . %{_sysconfdir}/java/java.conf
[ -z "$JAVA_HOME" ] && JAVA_HOME=%{_jvmdir}/java

# Remove old automated symlinks
# we do not want old links if a jar is removed from tomcat's layout
find %{serverdir}/webapps/admin/WEB-INF/lib -name '\[*\]*.jar' -not -type d -exec rm -f {} \;

build-jar-repository %{serverdir}/webapps/admin/WEB-INF/lib struts 2>&1


%post compat
# For Borland JBuilder
# Since we do not ensure a 1/1 jar mapping this won't always work
pushd %{commondir}/lib > /dev/null
   ln -fs \[ant\]*jar ant.jar
   ln -fs \[servletapi4\]*jar servlet.jar
popd > /dev/null
pushd %{commondir}/endorsed > /dev/null
   ln -fs \[jaxp_parser_impl\]*jar xercesImpl.jar
   ln -fs \[xml-commons-apis\]*jar xmlParserAPIs.jar
popd > /dev/null


%preun
# Always clean up wordir and tempdir on upgrade/removal
rm -fr %{workdir}/* %{tempdir}/*

if [ $1 = 0 ]; then
    [ -f /var/lock/subsys/%{name} ] && %{_sysconfdir}/init.d/%{name} stop
    [ -f %{_sysconfdir}/init.d/%{name} ] && /sbin/chkconfig --del %{name}

    %{_sbindir}/userdel %{name} >> /dev/null 2>&1 || :
    %{_sbindir}/groupdel %{name} >> /dev/null 2>&1 || :

    # Remove automated symlinks
    for repository in %{serverdir}/lib \
                      %{commondir}/lib \
                      %{commondir}/endorsed ; do
        find $repository -name '\[*\]*.jar' -not -type d -exec rm -f {} \;
    done
fi


%preun admin-webapps

if [ $1 = 0 ]; then
    find %{serverdir}/webapps/admin/WEB-INF/lib  \
         -name '\[*\]*.jar' -not -type d -exec rm -f {} \;
fi


%pre
# Add the "tomcat" user
# we need a shell to be able to use su - later
%{_sbindir}/useradd -c "Tomcat4" -u %{tcuid} \
    -s /bin/sh -r -d %{homedir} %{name} 2> /dev/null || :


%files -f %{packdname}/homelinks
%defattr(644,root,root,755)
%doc TOMCAT4.README.RPM %{packdname}/{LICENSE,README*,RELE*}
# Normal directories
%dir %{homedir}
%dir %{bindir}
%dir %{_localstatedir}/lib/%{name}
%dir %{commondir}
%dir %{serverdir}
%dir %{serverdir}/classes
%dir %{serverdir}/lib
%dir %{shareddir}
%dir %{shareddir}/classes
%dir %{shareddir}/lib

%{_javadir}/*.jar

# Directories with special permissions
%attr(770,root,tomcat4)		%dir                  %{appdir}
%attr(775,root,tomcat4)    	%dir                  %{confdir}
%attr(775,root,tomcat4)    	%dir                  %{tempdir}
%attr(775,root,tomcat4)    	%dir                  %{workdir}
%attr(755,tomcat4,tomcat4)	%dir                  %{logdir}

%attr(755,root,root) 	  	%{_bindir}/*
%attr(755,root,root) 	  	%{bindir}/*
%attr(755,root,root)  	  	%{_sysconfdir}/init.d/%{name}

%attr(644,root,tomcat4)    	%config(noreplace)      %{confdir}/catalina.policy
%attr(660,root,tomcat4)    	%config(noreplace)      %{confdir}/jk2.properties
%attr(660,root,tomcat4)    	%config(noreplace)      %{confdir}/tomcat-users.xml
%config(noreplace) %{confdir}/tomcat4.conf
%config(noreplace) %{confdir}/server.xml
%config(noreplace) %{confdir}/web.xml

%{confdir}/server-noexamples.xml.config
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%{commondir}/*
%{serverdir}/lib/*
%{tempdir}/README.txt

#exclude -compat parts
%exclude /etc/tomcat4/conf
%exclude /var/tomcat4
%exclude %{commondir}/lib/ant.jar
%exclude %{commondir}/lib/servlet.jar
%exclude %{commondir}/endorsed/xercesImpl.jar
%exclude %{commondir}/endorsed/xmlParserAPIs.jar

%files webapps
%defattr(640,root,tomcat4,770)
%{appdir}/examples/*
%{appdir}/ROOT/*
%{appdir}/tomcat-docs/*
%{appdir}/webdav/*

%files admin-webapps
%defattr(640,root,tomcat4,750)
%{appdir}/admin.xml
%{appdir}/manager.xml
%{serverdir}/webapps/*

%files compat
%defattr(644,root,root,755)
# JPackage 1.0
/etc/tomcat4/conf
/var/tomcat4
# Borland JBuilder
%ghost %{commondir}/lib/ant.jar
%ghost %{commondir}/lib/servlet.jar
%ghost %{commondir}/endorsed/xercesImpl.jar
%ghost %{commondir}/endorsed/xmlParserAPIs.jar


%changelog
* Thu Oct 09 2003 Paul Nasrat <pauln @ truemesh.com> 0:4.1.27-2jpp
- Fix requires for regexp

* Wed Aug 27 2003 Paul Nasrat <pauln @ truemesh.com> 0:4.1.27-1jpp
- Update to 4.1.27
- remove fileupload patch

* Wed Jul 23 2003 Nicolas Mailhot <Nicolas.Mailhot @ laPoste.net> 0:4.1.24-12jpp
- config(noreplace) logrotate file
- remove automated links on uninstall
- move catalina.jar to %{_javadir} so ant can use it
- move automated links creation to %post
- fileutils build fix (thanks Ville)
- restrict barf-o-matic to initial installation
- lots of rpm -V fixes

* Mon Jun 23 2003 Nicolas Mailhot <Nicolas.Mailhot @ laPoste.net> 0:4.1.24-11jpp
- fix owning of a few directories
- common/lib needs commons-logging-api, not commons-logging
[ once again credits go to Leonid Dubinsky for accurate reporting ]

* Thu Jun 12 2003 Nicolas Mailhot <Nicolas.Mailhot @ laPoste.net> 0:4.1.24-10jpp
- add Borland JBuilder -compat symlinks
- add javamail providers do the package
[ credits to Leonid Dubinsky for reporting this ]

* Thu Jun 12 2003 Nicolas Mailhot <Nicolas.Mailhot @ laPoste.net> 0:4.1.24-9jpp
- fix logrotate location
- add compat subpackage

* Tue Jun 10 2003 Nicolas Mailhot <Nicolas.Mailhot @ laPoste.net> 0:4.1.24-8jpp
- fix admin webapp config instead of workarounding.
- remove unused log4j dep

* Fri Jun 10 2003 Nicolas Mailhot <Nicolas.Mailhot @ laPoste.net> 0:4.1.24-7jpp
- copy jar files instead of linking them in webapps to work around jakarta bug

* Fri May 16 2003 Nicolas Mailhot <Nicolas.Mailhot @ laPoste.net> 0:4.1.24-6jpp
- Probably working version

* Fri May 16 2003 Nicolas Mailhot <Nicolas.Mailhot @ laPoste.net> 0:4.1.24-5jpp
- stricter fhs compliance
- use jpackge 1.5 jar autodetection routines
- doc still broken
- still needs rebuild-jar-repository calls at stertup to freshen links

* Mon May 12 2003 David Walluck <david@anti-microsoft.org> 0:4.1.24-4jpp
- add epoch to package
- add epoch's to all requires
- fix jta reuirement
- use -Dbuild.compiler=modern instead of use_jikes=false
- really set java.home for ant
- use %%_java macros
- use build-classpath
- remove unpackaged files (see comment)

* Thu May 08 2003 Henri Gomez <hgomez@users.sourceforge.net> 4.1.24-3jpp
- rebuild for jpackage 1.5
- avoid error reports when removing user at uninstall time

* Fri Mar 28 2003 Henri Gomez <hgomez@users.sourceforge.net> 4.1.24-2jpp
- 4.1.24
- use javamail instead of old monolithic javamail

* Wed Mar 19 2003 Henri Gomez <hgomez@users.sourceforge.net> 4.1.24-1jpp
- 4.1.24 alpha

* Tue Mar 18 2003 Henri Gomez <hgomez@users.sourceforge.net> 4.1.23-1jpp
- 4.1.23 alpha
- complete release include commons-fileupload-1.0-beta1

* Fri Mar 14 2003 Henri Gomez <hgomez@users.sourceforge.net> 4.1.22-3jpp
- fix init script

* Wed Mar 12 2003 Henri Gomez <hgomez@users.sourceforge.net> 4.1.22-2jpp
- rpm release 2
- init script control now that tomcat isn't allready running at start
- don't remove run/lock if tomcat stop failed in init script stop

* Mon Mar 10 2003 Henri Gomez <hgomez@users.sourceforge.net> 4.1.22-1jpp
- 4.1.22 alpha

* Thu Mar 06 2003 Henri Gomez <hgomez@users.sourceforge.net> 4.1.21-2jpp
- 4.1.21 beta
- rpm release 2
- improved tomcat script which will store main java process in file
  pointed by CATALINA_PID env var if existing, and will kill tomcat if
  it didn't stop after SHUTDOWN_WAIT seconds (tomcat4.conf)

* Wed Feb 26 2003 Henri Gomez <hgomez@users.sourceforge.net> 4.1.21-1jpp
- 4.1.21 alpha
- use mx4j 1.1.1 for which jar changed from mx4j.jar to mx4j-jmx.jar

* Thu Feb 13 2003 Henri Gomez <hgomez@users.sourceforge.net> 4.1.20-1jpp
- 4.1.20 alpha
- full version bundled with update beanutils 1.6

* Fri Jan 24 2003 Henri Gomez <hgomez@users.sourceforge.net> 4.1.19-2jpp
- rpm release 2
- fix rights on tomcat-users.xml and jk2.properties, only root and tomcat4
  user could update it (reported by Boris Folgmann)

* Wed Jan 15 2003 Henri Gomez <hgomez@users.sourceforge.net> 4.1.19-1jpp
- 4.1.19 alpha
- new requirement, commons-fileupload

* Fri Dec 20 2002 Ville SkyttÂä <ville.skytta at iki.fi> - 4.1.18-1jpp
- 4.1.18 stable, security update release.

* Wed Dec 18 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.17-1jpp
- 4.1.17 stable release

* Wed Dec 03 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.16-1jpp
- 4.1.16 beta release

* Wed Nov 27 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.16-1jpp
- 4.1.16 alpha release

* Tue Nov 19 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.15-1jpp
- 4.1.15 release

* Tue Oct 29 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.12-3jpp
- rpm release 3
- relax perms in webapps, tomcat4 could now write in it and as
  suck will be able to autoexpand wars.

* Mon Oct 07 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.12-2jpp
- rpm release 2
- fix tomcat4.conf to use /etc/java/java.conf
- fix tomcat4 initd to be sure that we'll stop/start the task owner by
  TOMCAT_USER and running catalina
- fix perms on %{confdir}, contents is owned by root.tomcat4, and only
  jk2.properties and tomcat-users.xml could be updated by tomcat4 user.
- change ref and use of xerces-j2.jar by jaxp_parser_impl.jar.
- include ant 1.5.1
- remove commons-lang as no more required
- copy a correct mod_jk.jpeg

* Mon Sep 30 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.12-1jpp
- 4.1.12 release
- include commons-logging 1.0.2, xerces-j2 2.1.0
- warning: do not use xerces-j2 2.2.0 which cause strange parse exception
  making Tomcat 4.1.12 to fail at startup

* Mon Sep 16 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.10-4jpp
- rpm release 4
- fixed java.conf location in misc documents and messages

* Fri Sep 13 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.10-3jpp
- rpm release 3
- fix TOMCAT4.README.RPM documentation

* Fri Sep 12 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.10-2jpp
- rpm release 2
- fix java.conf location
- webapps are owned by root:tomcat4 750/640
- fix initd script to ensure using pidof catalina

* Mon Sep 09 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.10-1jpp
- 4.1.10 release
- jasper jars moved from shared/lib to common/lib
- full version bundled with latest release of :
  javamail 1.3, jaf 1.0.2, beanutils 1.4.1, commons-pool 1.0.1

* Fri Aug 23 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.9-4jpp
- rpm release 4
- Requires jta-1.0.1a

* Thu Aug 22 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.9-3jpp
- rpm release 3
- the rpm could be now built in 3 modes :
  ligth, follow jakarta LE tarball, ie didn't include stuff present in JDK 1.4
  full,  follow jakarta FULL tarball, ie include everything needed
  strict, include only tomcat stuff, requires all others to be allready present
  (jakarta-commons-*, regexp, serlvet-2.3...)
- commons-logging, regexp and servlet jars should be also included in LE mode
- TOMCAT4.README.RPM updated
- copy struts.jar in admin-webapp since symlinking it make admin webapp failed !

* Thu Aug 22 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.9-2jpp
- rpm release 2
- fix jasper4 and jspc4 scripts
- set Vendor and Distribution tags to JPackage
- add JSSE if found in usual JPackage location (%{_javadir})

* Tue Aug 20 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.9-1jpp
- 4.1.9
- add commons-lang to required package for build
- make use of commons-logging 1.0.1
- remove the ugly hack in start/stop

* Tue Aug 20 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.7-2jpp
- rpm release 2
- fix jdbcext jar name
- use jakarta-commons-logging 1.0.1 release package
- use jpackage-utils in tomcat4.conf and correct /etc/java.conf check

* Wed Jul 10 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.1.7-1jpp
- tomcat 4.1.7
- take care of new jaxp apis/impl policy
- update build since jsse is now under javadir/jsse
- new package, admin-webapps
- tomcat4 need write access to the conf dir, so the dir is owned by tomcat4

* Wed Jun 26 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.0.4-2jpp
- rpm release 2
- change build order : jtc/util, tc4, jtc/coyote, jtc/jk
- the rpm requires that you define your system Java SDK in /etc/java.conf
  or %{confdir}/%{name}.conf (at least define JAVA_HOME)
  Take a look at TOMCAT4.README.RPM for more explanations
- layout changes to meet FHS recommandations :
- use /var/cache/tomcat4 instead of /var/run/tomcat4/{work,temp}
- moved conf from /etc/tomcat4/conf to /etc/tomcat4
- logs/work/temp and webapps now owned by tomcat4 user
- fix regexp name and location

* Mon Jun 24 2002 Henri Gomez <hgomez@users.sourceforge.net> 4.0.4-1jpp
- tomcat-v4.0.4
- this rpm is equivalent to jakarta-tomcat-4.0.4 full.
- tomcat4 is more FHS compliant, using symlinks to homedir
- tomcat4 use standard port, relocation command reloctomcat4 is
  provided to make it listen to alternate ports to make it
  compatible with a present tomcat 3.3
- unique rpm for both jpackage.org and jakarta.org
- commons-logging is the one from packager site until an official 1.0.1
  release will be out
- Take a look at TOMCAT4.README.RPM for more informations about RPM

* Tue Apr 30 2002 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0.4-b2
- correct postun script, remove linked jars after service stop

* Fri Apr 26 2002 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0.3 rpm release 2
- misc spec/rpm fixes.

* Mon Mar 04 2002 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0.3
- security fix
- add symlinking info at post time

* Tue Feb 19 2002 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0.2 RPM release 3
- correct missing tools.jar in CLASSPATH in both tomcat4 and jasper4

* Fri Feb 15 2002 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0.2 RPM release 2
- correct bad perms for webapps dir
- warn user at install time if ext jars are not found
- use new tarball for JTC (jakarta-tomcat-connectors-4.0.2-01-src)

* Mon Feb 11 2002 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0.2
- rpm use the light distribution mode whereas jndi, javamail, jta and jdbc-ext
  are not required.
- rpm now is fully rpm compliant, jakarta-regexp, servletapi4, xerces rpm are
  required for build and should be present, they will be linked at install time.

* Wed Jan 23 2002 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0.2-b2
- removed tomcat 4.0.2-b2 binary tarball to save place in srpm
- removed manual package, stuff will be only in webapps
- due to Sun Licence we couldn't provide jaf, javamail, jdbc-ext, jmxri, jndi, jta
  jars in source package, so the build dependencies will require to have them
  ALLREADY present in %{_javadir}.
- rpm 4.0.3 have problem with _ in dependencies, jdbcext/jta buildrequire has
  been commented BUT are needed

* Fri Oct 24 2001 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0.1
- ajp13 support is now included by default in Tomcat 4.0, so I've included
  stuff from jakarta-tomcat-connectors CVS (20011023) to rebuild ajp connector
  from source
- since you could have also a tomcat 3.x running, listen port in Tomcat 4.0
  rpm have been translated :
  HTTP 1.1 from 8080 to 8180, Proxied HTTP 1.1 from 8081 to 8181,
  HTTP 1.1/SSL from 8443 to 8543 and AJP13 from 8009 to 8109
  HTTP 1.0 from port 8082 to 8182
  if you want to use original values, edit file %{homedir}/conf/server.xml
- connectors activated by default are HTTP 1.1, WARP and AJP13
- rework RPM to have tomcat4 works under user tomcat4 (like tomcat 3.3 RPM)
- fix images corruptions

* Mon Oct 08 2001 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0
- to avoid license problem both source and binary are included in the source rpm
  we use binary tarball to get required jar, jndi, mail, jta...
- Java Managment Extension, jmx is included in source rpm for build purpose but
  won't be installed in binary rpm again for license problem.
- many RPM enhancements from suggestion from Keith Irwin <keith_irwin@non.hp.com>,
  Nicolas Mailhot <nicolas.mailhot@one2team.com> and Jun Inamori. A big thanks
  to all of them
- tomcat run as nobody (finally) in init.d.
  BE CAREFULL NOW WHEN running tomcat as root (in interactive mode for example)
  since you could then make some files unreadable
- a config file is available for init.d script tuning, tomcat.conf, in %{confdir}
- no external parser is required since crimson (jaxp 1.1) is now included
- this RPM is still not FHS, need some reworks...
- no external parser is required since crimson (jaxp 1.1) is now included
- built under Redhat 6.2 with updates, jikes 1.15, ant 1.4, IBM JDK 1.3 (cx130-20010626), jsse 1.0.2

* Thu Sep 13 2001 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0-rc1
- built under Redhat 6.2 with updates, jikes 1.14, IBM JDK 1.3 (cx130-20010626), jsse 1.0.2

* Tue Jun 05 2001 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0b5
- built under Redhat 6.2 with updates, jikes 1.14, IBM JDK 1.3 (cx130-20010502), jsse 1.0.2
- included xerces 1.4.0

* Fri May 11 2001 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0b4

* Wed Apr 18 2001 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0b3

* Mon Apr 02 2001 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0b2
- second beta release of tomcat 4
- big cleanup of the SPEC which was just to complex.
- Need now a jaxp 1.1 conforming parser, => require xerces-j 1.3.1
- removed jaxp 1.0 / 1.1 from SPEC since we're using xerces-j 1.3.1
  (jaxp 1.1 / crimson is include in tomcat sources)
- YOU MUST HAVE the JSSE 1.0.2 jars in /usr/share/java (I've built a
  jsse RPM from Sun Jars but I COULD'T MAKE IT AVAILABLE...)

* Mon Jan 08 2001 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0b1
- first beta release of tomcat 4

* Thu Dec 14 2000 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0m5

* Thu Nov 02 2000 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0m4

* Tue Oct 24 2000 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0m3 RPM Release 2
- corrected jars included
- we assume you've installed jsse jars in /usr/share/java
- renamed tomcat4-doc to tomcat4-manual (follow apache RPM naming)
- RH 7.0 changes location of docdir and DocumentRoot. The spec file is modified
  to place manual in right place when rebuilded under RH 6.x or RH 7.0
- compiled on Redhat 6.1 box plus updates with rpm-3.0.5
- build CLASSPATH=

* Thu Oct 19 2000 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0m3

* Tue Oct 17 2000 Henri Gomez <hgomez@users.sourceforge.net>
- tomcat-v4.0m2 RPM Release 2
- follow Debian policy about java stuff, libs in /usr/share/java,
  executable in /usr/bin, apps datas in %{homedir}
- prepare transition to RH 7.0 new document root (/var/www)
- build CLASSPATH=/usr/share/java/jsse.jar:/usr/share/java/jcert.jar:/usr/share/java/jnet.jar

* Thu Oct 12 2000 Henri Gomez <hgomez@users.sourceforge.net>
- v4.0-m2
- to allow tomcat 3.x and tomcat 4.x coexistence, the RPM is named tomcat4.
  It start at version 4.0 and all datas will goes in /home/tomcat4.
- tomcat 4.0 need ant post 1.1, xerces 1.2.0, jsse 1.0.1 (min) and jmx.
  The RPM include ant post 1.1 (for build) and jmx (jmxri.jar for build/run) .
  I couldn't include JSSE stuff so you must download JSSE from java.sun.com.
  Next install jcert.jar, jnet.jar and jsse.jar in BOTH
  /usr/lib/java AND JAVA_HOME/jre/lib/ext
- TC 4.0 HTTP 1.1 connector moved from port 8080 to 8180 and
  from port 8081 to 8181 for HTTP 1.0 connector
  (TC 3.x allready listen on 8080/8081)

* Sat Oct 07 2000 Henri Gomez <hgomez@users.sourceforge.net>
- v4.0-m1
- RPM never released

* Fri Oct 06 2000 Henri Gomez <hgomez@users.sourceforge.net>
- RPM release 2
- tomcat is now installed on /home/tomcat instead of
  /opt/tomcat since /opt is mounted read-only on
  many systems <summer@os2.ami.com.au>
- build CLASSPATH=/usr/lib/java/jsse.jar:/usr/lib/java/jcert.jar:/usr/lib/java/jnet.jar
- correct stuff in spec file (copyright, group...)

* Mon Sep 25 2000 Henri Gomez <hgomez@users.sourceforge.net>
- v3.2-beta-5 RPM
- detect jikes and use it to rebuild (yep 10 times faster).
- patched incorrect version number
- rebuilded with jikes 1.12 (and jsse 1.0.2).
